compile if not defined(SMALL)  -- If SMALL not defined, then being separately compiled
 define INCLUDING_FILE = 'GMLTAGS.E'
const
   tryinclude 'MYCNF.E'        -- the user's configuration customizations.

 compile if not defined(SITE_CONFIG)
    const SITE_CONFIG = 'SITECNF.E'
 compile endif
 compile if SITE_CONFIG
    tryinclude SITE_CONFIG
 compile endif
compile endif

const
compile if not defined(COMPANY_NAME)
   COMPANY_NAME = ''            -- Include a trailing blank if a company name is given.
compile endif
compile if not defined(WANT_DYNAMIC_PROMPTS)
   WANT_DYNAMIC_PROMPTS = 1
compile endif
compile if EVERSION < '5.21'
   TILDE_CHAR = ''
compile else
   TILDE_CHAR = '~'
compile endif
   AF_CHAR        =   1   -- key style constants (from STDCONST.E)
   AF_ALT         =  32

const  -- Text defined separately, for easier NLS translation
   GMLTAGS_BAR__MSG =      TILDE_CHAR'GML '
     PARAGRAPH_MENU__MSG = '~Paragraph'
     LIST_ITEM_MENU__MSG = '~List item'
     QUOTE_MENU__MSG =     '~Quote'
     CENTER_MENU__MSG =    '~Center'
     UNDERLINE_MENU__MSG = 'U~nderline'
     OLIST_MENU__MSG =     '~Ordered list'
     ULIST_MENU__MSG =     '~Unordered list'
     SLIST_MENU__MSG =     '~Simple list'
     DLIST_MENU__MSG =     '~Definition list'
     PLIST_MENU__MSG =     'P~arameter list'
     FIGURE_MENU__MSG =    '~Figure'
     TABLE_MENU__MSG =     '~Table'
     HEADS_MENU__MSG =     '~Heading levels'
       HEAD0_MENU__MSG =   'Heading ~0'
       HEAD1_MENU__MSG =   'Heading ~1'
       HEAD2_MENU__MSG =   'Heading ~2'
       HEAD3_MENU__MSG =   'Heading ~3'
       HEAD4_MENU__MSG =   'Heading ~4'
       HEAD5_MENU__MSG =   'Heading ~5'
       HEAD6_MENU__MSG =   'Heading ~6'
     HP_MENU__MSG =        'H~ighlighted phrase'
       HP0_MENU__MSG =     '~0 (Normal)'
       HP1_MENU__MSG =     '~1 (Italic or Underscore)'
       HP2_MENU__MSG =     '~2 (Bold)'
       HP3_MENU__MSG =     '~3 (Bold Italic)'
     LINKS_MENU__MSG =     'Lin~ks'
       LINKHD_MENU__MSG =    '~Heading link...'
       LINKFN_MENU__MSG =    '~Footnote reference...'
     DOC_MENU__MSG =       'Docu~ments'
       GDOC_MENU__MSG =      '~GDOC'
       BUSERDOC_MENU__MSG =   'Bookmaster ~UserDOC'
       IUSERDOC_MENU__MSG =   '~IPF UserDOC'

compile if WANT_DYNAMIC_PROMPTS
   GMLTAGS_BARP__MSG =      \1'Create GML tags'
     PARAGRAPH_MENUP__MSG = \1'Insert paragraph tag after current line'
     LIST_ITEM_MENUP__MSG = \1'Insert list item tag after current line'
     QUOTE_MENUP__MSG =     \1'Insert quote tags around block or char. mark, or current word'
     CENTER_MENUP__MSG =    \1'Insert center tag at beginning of line'
     UNDERLINE_MENUP__MSG = \1'Insert underline tag at beginning of line'
     OLIST_MENUP__MSG =     \1'Create ordered list'
     ULIST_MENUP__MSG =     \1'Create unordered list'
     SLIST_MENUP__MSG =     \1'Create simple list'
     DLIST_MENUP__MSG =     \1'Create definition list'
     PLIST_MENUP__MSG =     \1'Create parameter list'
     FIGURE_MENUP__MSG =    \1'Create a figure'
     TABLE_MENUP__MSG =     \1'Create a table'
     HEADS_MENUP__MSG =     \1'Insert heading levels at beginning of line'
       HEAD0_MENUP__MSG =     \1'[New page / 5 spaces after][Capitalize][Underscore][Bold][TOC]'
       HEAD1_MENUP__MSG =     \1'[New page / 3 spaces after][Capitalize][Underscore][Bold][TOC]'
       HEAD2_MENUP__MSG =     \1'[3 spaces before / 2 spaces after][Capitalize][Underscore][Bold][TOC]'
       HEAD3_MENUP__MSG =     \1'[3 spaces before / 2 spaces after][Underscore][Bold][TOC]'
       HEAD4_MENUP__MSG =     \1'[3 spaces before / 2 spaces after][Bold][TOC]'
       HEAD5_MENUP__MSG =     \1'[1 space before / Text follows on same line][Bold][no TOC]'
       HEAD6_MENUP__MSG =     \1'[1 space before / Text follows on same line][Underscore][no TOC]'
     HP_MENUP__MSG =        \1'Highlight phrase - block or char. mark, or current word'
       HP0_MENUP__MSG =       \1'Highlight phrase 0 - Normal text'
       HP1_MENUP__MSG =       \1'Highlight phrase 1 - Underscore text'
       HP2_MENUP__MSG =       \1'Highlight phrase 2 - Boldface text'
       HP3_MENUP__MSG =       \1'Highlight phrase 3 - Underscore and boldface text'
     LINKS_MENUP__MSG =     \1'Add a link around block or char. mark, or current word'
       LINKHD_MENUP__MSG =    \1'Add a link to a heading'
       LINKFN_MENUP__MSG =    \1'Add a link to a footnote'
     DOC_MENUP__MSG =       \1'Create a document'
       GDOC_MENUP__MSG =      \1'Create a GDOC (General Document)'
       BUSERDOC_MENUP__MSG =  \1'Create a Bookmaster User Document'
       IUSERDOC_MENUP__MSG =  \1'Create an IPF User Document'
compile else
   GMLTAGS_BARP__MSG =      ''
     PARAGRAPH_MENUP__MSG = ''
     LIST_ITEM_MENUP__MSG = ''
     QUOTE_MENUP__MSG =     ''
     CENTER_MENUP__MSG =    ''
     UNDERLINE_MENUP__MSG = ''
     OLIST_MENUP__MSG =     ''
     ULIST_MENUP__MSG =     ''
     SLIST_MENUP__MSG =     ''
     DLIST_MENUP__MSG =     ''
     PLIST_MENUP__MSG =     ''
     FIGURE_MENUP__MSG =    ''
     TABLE_MENUP__MSG =     ''
     HEADS_MENUP__MSG =     ''
       HEAD0_MENUP__MSG =   ''
       HEAD1_MENUP__MSG =   ''
       HEAD2_MENUP__MSG =   ''
       HEAD3_MENUP__MSG =   ''
       HEAD4_MENUP__MSG =   ''
       HEAD5_MENUP__MSG =   ''
       HEAD6_MENUP__MSG =   ''
     HP_MENUP__MSG =        ''
       HP0_MENUP__MSG =     ''
       HP1_MENUP__MSG =     ''
       HP2_MENUP__MSG =     ''
       HP3_MENUP__MSG =     ''
     LINKS_MENUP__MSG =     ''
       LINKHD_MENUP__MSG =  ''
       LINKFN_MENUP__MSG =  ''
     DOC_MENUP__MSG =        ''
       GDOC_MENUP__MSG =     ''
       BUSERDOC_MENUP__MSG = ''
       IUSERDOC_MENUP__MSG = ''
compile endif  -- WANT_DYNAMIC_PROMPTS

   LINK_TITLE__MSG =  ':Link. arguments'
   LINK_PROMPT__MSG = 'Enter the heading reference id or the resource id'
   OK__MSG =          '~OK'
   CANCEL__MSG =      'Cancel'  -- This is also in ENGLISH.E

   SECURITY_TITLE__MSG =  'Document security'
   SECURITY_PROMPT__MSG = 'Select the desired security level'
   SECURITY_LEVELS__MSG = '/Unclassified/'COMPANY_NAME'Internal Use Only/'COMPANY_NAME'Confidential/'COMPANY_NAME'Confidential-Restricted/Registered 'COMPANY_NAME'Confidential'
   SELECT__MSG =          '~Select'
   NONE__MSG =            '~None'

definit
   universal defaultmenu, activemenu
   universal activeaccel
   universal GML_tags_menu_flag
   deletemenu defaultmenu, 6, 0, 0  -- delete the existing Help menu (we want it to stay at the right)

   buildsubmenu defaultmenu, 38, GMLTAGS_BAR__MSG, GMLTAGS_BARP__MSG, 0, 0
     buildmenuitem defaultmenu,   38, 3800, PARAGRAPH_MENU__MSG,     'GML_IL :p.'PARAGRAPH_MENUP__MSG, 0, 0
     buildmenuitem defaultmenu,   38, 3801, \0,                      '',      4, 0
     buildmenuitem defaultmenu,   38, 3802, LIST_ITEM_MENU__MSG,     'GML_IL :li.'LIST_ITEM_MENUP__MSG, 0, 0
     buildmenuitem defaultmenu,   38, 3803, QUOTE_MENU__MSG,         'GML_quote'QUOTE_MENUP__MSG, 0, 0
     buildmenuitem defaultmenu,   38, 3804, CENTER_MENU__MSG,        'GML_pref .ce 'CENTER_MENUP__MSG, 0, 0
     buildmenuitem defaultmenu,   38, 3805, UNDERLINE_MENU__MSG,     'GML_pref .us 'UNDERLINE_MENUP__MSG, 0, 0
     buildmenuitem defaultmenu,   38, 3806, \0,                      '',      4, 0
     buildmenuitem defaultmenu,   38, 3810, OLIST_MENU__MSG,         'GML_IML /:ol./:li./:li./:eol.'OLIST_MENUP__MSG, 0, 0
     buildmenuitem defaultmenu,   38, 3811, ULIST_MENU__MSG,         'GML_IML /:ul./:li./:li./:eul.'ULIST_MENUP__MSG, 0, 0
     buildmenuitem defaultmenu,   38, 3812, SLIST_MENU__MSG,         'GML_IML /:sl./:li./:li./:esl.'SLIST_MENUP__MSG, 0, 0
     buildmenuitem defaultmenu,   38, 3813, DLIST_MENU__MSG,         'GML_IML /:dl./:dt./:dd./:edl.'DLIST_MENUP__MSG, 0, 0
     buildmenuitem defaultmenu,   38, 3814, PLIST_MENU__MSG,         'GML_IML /:parml./:pt./:pd./:eparml.'PLIST_MENUP__MSG, 0, 0
     buildmenuitem defaultmenu,   38, 3815, \0,                      '',      4, 0
     buildmenuitem defaultmenu,   38, 3816, FIGURE_MENU__MSG,        'GML_IML /:fig./:figcap./:figdesc.//:efig.'FIGURE_MENUP__MSG, 0, 0
     buildmenuitem defaultmenu,   38, 3817, TABLE_MENU__MSG,         'GML_IML /:table./:tcap./:tdesc./:etdesc./:etable.'TABLE_MENUP__MSG, 0, 0
     buildmenuitem defaultmenu,   38, 3819, \0,                      '',      4, 0
     buildmenuitem defaultmenu,   38, 3820, HEADS_MENU__MSG,         HEADS_MENUP__MSG, 17, 0
       buildmenuitem defaultmenu, 38, 3821, HEAD0_MENU__MSG,         'GML_pref :h0.'HEAD0_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 38, 3822, HEAD1_MENU__MSG,         'GML_pref :h1.'HEAD1_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 38, 3823, HEAD2_MENU__MSG,         'GML_pref :h2.'HEAD2_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 38, 3824, HEAD3_MENU__MSG,         'GML_pref :h3.'HEAD3_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 38, 3825, HEAD4_MENU__MSG,         'GML_pref :h4.'HEAD4_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 38, 3826, HEAD5_MENU__MSG,         'GML_pref :h5.'HEAD5_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 38, 3827, HEAD6_MENU__MSG,         'GML_pref :h6.'HEAD6_MENUP__MSG, 32769, 0
     buildmenuitem defaultmenu,   38, 3830, HP_MENU__MSG,            HP_MENUP__MSG, 17, 0
       buildmenuitem defaultmenu, 38, 3831, HP0_MENU__MSG,           'GML_hp 0'HP0_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 38, 3832, HP1_MENU__MSG,           'GML_hp 1'HP1_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 38, 3833, HP2_MENU__MSG,           'GML_hp 2'HP2_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 38, 3834, HP3_MENU__MSG,           'GML_hp 3'HP3_MENUP__MSG, 32769, 0
     buildmenuitem defaultmenu,   38, 3840, LINKS_MENU__MSG,         LINKS_MENUP__MSG, 17, 0
       buildmenuitem defaultmenu, 38, 3841, LINKHD_MENU__MSG,         'GML_link hd'LINKHD_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 38, 3842, LINKFN_MENU__MSG,         'GML_link fn'LINKFN_MENUP__MSG, 32769, 0
     buildmenuitem defaultmenu,   38, 3850, DOC_MENU__MSG,           DOC_MENUP__MSG, 17, 0
       buildmenuitem defaultmenu, 38, 3851, GDOC_MENU__MSG,          'GML_GDOC'GDOC_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 38, 3852, BUSERDOC_MENU__MSG,      'GML_USERDOC'BUSERDOC_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 38, 3853, IUSERDOC_MENU__MSG,      'GML_IML /:userdoc./:docprof toc=123./:h1./:euserdoc.'IUSERDOC_MENUP__MSG, 32769, 0

   call readd_help_menu()
   GML_tags_menu_flag = 1

   buildacceltable activeaccel, 'dokey a+G', AF_CHAR+AF_ALT,    71, 3898  -- a+G
   buildacceltable activeaccel, 'dokey a+G', AF_CHAR+AF_ALT,   103, 3899  -- a+g
   activateacceltable  activeaccel

defc GML_IL = -- InsertLine
   insertline arg(1), .line+1
   '+1'
   end_line

defc GML_pref = -- Prefix line with arg
   replaceline arg(1) || textline(.line), .line
   .col = length(arg(1))+1

defc GML_IML = -- Insert Many Lines
   parse value strip(arg(1),'L') with delim 2 rest
   nextline = .line+1
   do while rest <> ''
      parse value rest with line (delim) rest
      insertline line, nextline
      nextline = nextline + 1
   enddo
   '+2'
   end_line

defc GML_quote
   call GML_insert_tags(':q.', ':eq.')

defc GML_hp
   level = arg(1)
   call GML_insert_tags(':hp'level'.', ':ehp'level'.')

defc hdlink =
   parse arg refid reftype .
   if refid='' then sayerror 'Missing refid.'; return; endif
   if isnum(refid) then
      refres = 'res'
   else
      refres = 'refid'
   endif
   if reftype='' then reftype='hd'; endif
   call GML_insert_tags(':link' refres'='refid 'reftype='reftype'.', ':elink.')

defc GML_link =
   parse arg reftype .
   parse value entrybox(LINK_TITLE__MSG,'/'OK__MSG'/'Cancel__MSG'/',\0,'',200,
          atoi(1) || atoi(0) || gethwndc(APP_HANDLE) ||
          LINK_PROMPT__MSG) with button 2 refid \0
   if button<>\1 then return; endif
   if isnum(refid) then
      refres = 'res'
   else
      refres = 'refid'
   endif
   if reftype='' then reftype='hd'; endif
   call GML_insert_tags(':link' refres'='refid 'reftype='reftype'.', ':elink.')

defproc GML_insert_tags(start_tag, end_tag)
   mt = marktype()
   if pos(leftstr(mt,1), 'BC') then  -- Block or Character mark
      getfileid fid
      getmark firstline,lastline,firstcol,lastcol,fileid
      if fid<>fileid then
         sayerror 'Wrong file - check mark'
         return
      endif
   else
      firstline = .line; lastline = .line;
      call pend_word(); lastcol = .col
      call pbegin_word(); firstcol = .col
   endif
   .col=lastcol+1
   lastline
   i_s = insert_state()
   if not i_s then insert_toggle; endif
   keyin end_tag
   firstline
   .col=firstcol
   keyin start_tag
   if pos(leftstr(mt,1), 'BC') then  -- Block or Character mark
      l = length(start_tag)
      call pset_mark(firstline, lastline, firstcol+l, lastcol+(l*(lastline=firstline)), mt, fileid)
   endif
   if not i_s then insert_toggle; endif

defc GML_GDOC
   if not GML_security(security) then
      return
   endif
   if security<>'' then
      security = " sec='"security"'"
   endif
   start_line = .line
   'GML_IML /:gdoc'security'./:frontm./:titlep./:title./:docnum./:date./:author./:address./:aline./:eaddress./:etitlep.' ||
           '/:abstract./:preface./:toc./:figlist./:tlist./:body./:appendix./:backm./:index./:egdoc.'
   start_line+4; end_line

defc GML_USERDOC
   if not GML_security(security) then
      return
   endif
   if security<>'' then
      security = " sec='"security"'"
   endif
   start_line = .line
   start_size = .last
   "GML_IML /:userdoc"security"./:prolog./:docprof style=./:title stitle='[short title]'./:library./[First line of library part of title]/[Next line of library part of title]/:topic./[First line of topic part of title]/[Next line of topic part of title]"
   start_line + .last - start_size
   "GML_IML /:release.[Release identification]/:etitle./:pgmnum.[Program number]/:author.[Writer's name]/:address./[First line of address]/[And as many more as you need]/:address.&rbl./:address.Filename: &$fnam/:eaddress./:date.[Specific date or blank]"
   start_line + .last - start_size
   "GML_IML /:docnum.[Document number]/:filenum.[File number]/:bindnum.[Binder number]/:vendor.Company name/:prtloc.Printing location (other than USA)/:eprolog."
   start_line + .last - start_size
   "GML_IML /:frontm./:tipage./:snotice.//:esnotice./:synopsis.//:esynopsis./:notices./:nitem subject='[subject of notice]'./:enotices./:vnotice./:vnhd.[Edition notice heading]//:evnotice."
   start_line + .last - start_size
   "GML_IML /:preface./:toc./:figlist./:tlist./:body./:appendix./:backm./:glossary./:index./:euserdoc."
   start_line+3; end_line

defproc GML_security(var security)
   parse value listbox(SECURITY_TITLE__MSG, SECURITY_LEVELS__MSG,
                       '/'SELECT__MSG'/'NONE__MSG'/'Cancel__MSG,1,5,5,0,
                       atoi(1) || atoi(1) || atoi(0) || atol(0) || SECURITY_PROMPT__MSG) with button 2 security \0
   if button=\2 then  -- None
      security = ''
   elseif button<>\1 then  -- Other than Select or None means Cancel or Close
      return 0
   endif
   return 1
